/* PulseAudioManager.c generated by valac 0.48.19, the Vala compiler
 * generated from PulseAudioManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2016-2018 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/*
 * Vocabulary of PulseAudio:
 *  - Source: Input (microphone)
 *  - Sink: Output (speaker)
 */

#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "pulse/ext-stream-restore.h"

#define SOUND_TYPE_PULSE_AUDIO_MANAGER (sound_pulse_audio_manager_get_type ())
#define SOUND_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager))
#define SOUND_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))
#define SOUND_IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))

typedef struct _SoundPulseAudioManager SoundPulseAudioManager;
typedef struct _SoundPulseAudioManagerClass SoundPulseAudioManagerClass;
typedef struct _SoundPulseAudioManagerPrivate SoundPulseAudioManagerPrivate;

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_0_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES
};
static GParamSpec* sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SoundPulseAudioManagerSetDefaultDeviceData SoundPulseAudioManagerSetDefaultDeviceData;
typedef struct _Block6Data Block6Data;
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
typedef struct _SoundPulseAudioManagerSetCardProfileByIndexData SoundPulseAudioManagerSetCardProfileByIndexData;
typedef struct _Block7Data Block7Data;
typedef struct _SoundPulseAudioManagerWaitForUpdateData SoundPulseAudioManagerWaitForUpdateData;
typedef struct _Block8Data Block8Data;
typedef struct _SoundPulseAudioManagerSetSinkPortByNameData SoundPulseAudioManagerSetSinkPortByNameData;
typedef struct _Block9Data Block9Data;
typedef struct _SoundPulseAudioManagerSetSourcePortByNameData SoundPulseAudioManagerSetSourcePortByNameData;
typedef struct _Block10Data Block10Data;
typedef struct _SoundPulseAudioManagerSetDefaultSinkData SoundPulseAudioManagerSetDefaultSinkData;
typedef struct _Block11Data Block11Data;
typedef struct _SoundPulseAudioManagerSetDefaultSourceData SoundPulseAudioManagerSetDefaultSourceData;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _SoundPulseAudioManagerReconnectToPulseData SoundPulseAudioManagerReconnectToPulseData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
enum  {
	SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL,
	SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS
};
static guint sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS] = {0};

struct _SoundPulseAudioManager {
	GObject parent_instance;
	SoundPulseAudioManagerPrivate * priv;
};

struct _SoundPulseAudioManagerClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerPrivate {
	pa_context* context;
	pa_glib_mainloop* loop;
	gboolean is_ready;
	guint reconnect_timer_id;
	GeeHashMap* input_devices;
	GeeHashMap* output_devices;
	SoundDevice* _default_output;
	SoundDevice* _default_input;
	gchar* default_source_name;
	gchar* default_sink_name;
};

struct _SoundPulseAudioManagerSetDefaultDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SoundDevice* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SoundDevice* _tmp8_;
	SoundDevice* _tmp9_;
	SoundDevice* other_device;
	SoundDevice* _tmp10_;
	gchar* profile_name;
	SoundDevice* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	GeeArrayList* _tmp14_;
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	guint32 _tmp23_;
	guint32 _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gboolean _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	gboolean _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
	gboolean _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	const gchar* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	gboolean _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	const gchar* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
};

struct _Block6Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetCardProfileByIndexData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	Block6Data* _data6_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block7Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gulong handler_id;
	SoundDevice* device;
	gchar* prop_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerWaitForUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	gchar* prop_name;
	Block7Data* _data7_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gulong _tmp3_;
};

struct _Block8Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSinkPortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	Block8Data* _data8_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block9Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSourcePortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	Block9Data* _data9_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block10Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSinkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	Block10Data* _data10_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block11Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSourceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* source_name;
	Block11Data* _data11_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _SoundPulseAudioManagerReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	pa_context* _tmp0_;
	pa_proplist* props;
	pa_proplist* _tmp1_;
	pa_proplist* _tmp2_;
	pa_glib_mainloop* _tmp3_;
	pa_mainloop_api* _tmp4_;
	pa_proplist* _tmp5_;
	pa_context* _tmp6_;
	pa_context* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	const gchar* _tmp10_;
};

static gint SoundPulseAudioManager_private_offset;
static gpointer sound_pulse_audio_manager_parent_class = NULL;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam = NULL;
static gboolean sound_pulse_audio_manager_debug_enabled;
static gboolean sound_pulse_audio_manager_debug_enabled = FALSE;
extern GSettings* sound_indicator_settings;

GType sound_pulse_audio_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SoundPulseAudioManager, g_object_unref)
GType sound_device_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SoundDevice, g_object_unref)
SoundPulseAudioManager* sound_pulse_audio_manager_get_default (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_new (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_construct (GType object_type);
void sound_pulse_audio_manager_start (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_device_data_free (gpointer _data);
void sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                                   SoundDevice* device,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
void sound_pulse_audio_manager_set_default_device_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static gboolean sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_);
const gchar* sound_device_get_id (SoundDevice* self);
gboolean sound_device_get_input (SoundDevice* self);
SoundDevice* sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self);
SoundDevice* sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self);
gchar* sound_device_get_matching_profile (SoundDevice* self,
                                          SoundDevice* other_device);
GeeArrayList* sound_device_get_profiles (SoundDevice* self);
const gchar* sound_device_get_card_active_profile_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                          guint32 card_index,
                                                          const gchar* profile_name,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                                 GAsyncResult* _res_);
guint32 sound_device_get_card_index (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                const gchar* prop_name,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                       GAsyncResult* _res_);
const gchar* sound_device_get_port_name (SoundDevice* self);
const gchar* sound_device_get_card_sink_port_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                      const gchar* sink_name,
                                                      const gchar* port_name,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                             GAsyncResult* _res_);
const gchar* sound_device_get_card_sink_name (SoundDevice* self);
const gchar* sound_device_get_card_source_port_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                        const gchar* source_name,
                                                        const gchar* port_name,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                               GAsyncResult* _res_);
const gchar* sound_device_get_card_source_name (SoundDevice* self);
const gchar* sound_device_get_sink_name (SoundDevice* self);
const gchar* sound_device_get_source_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda45_ (Block6Data* _data6_,
                  pa_context* c,
                  gint success);
static void ___lambda45__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda46_ (Block7Data* _data7_,
                  GObject* s,
                  GParamSpec* p);
static void ___lambda46__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda47_ (Block8Data* _data8_,
                  pa_context* c,
                  gint success);
static void ___lambda47__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda48_ (Block9Data* _data9_,
                  pa_context* c,
                  gint success);
static void ___lambda48__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda49_ (Block10Data* _data10_,
                  pa_context* c,
                  gint success);
static void ___lambda49__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_source_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda50_ (Block11Data* _data11_,
                  pa_context* c,
                  gint success);
static void ___lambda50__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static gboolean sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_);
static void sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                       pa_context* c);
static void _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                               gpointer self);
static void sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_subscription_event_type_t t,
                                                   guint32 index);
static void _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                              pa_subscription_event_type_t t,
                                                                              guint32 idx,
                                                                              gpointer self);
static void sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* context,
                                                     pa_server_info* server);
static void _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                          pa_server_info* i,
                                                                          gpointer self);
static gboolean _sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self);
static void sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_sink_info* sink,
                                                   gint eol);
static void _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                      pa_sink_info* i,
                                                                      gint eol,
                                                                      gpointer self);
gint sound_device_get_sink_index (SoundDevice* self);
void sound_device_set_sink_name (SoundDevice* self,
                                 const gchar* value);
void sound_device_set_sink_index (SoundDevice* self,
                                  gint value);
void sound_device_set_is_default (SoundDevice* self,
                                  gboolean value);
gint sound_device_get_card_sink_index (SoundDevice* self);
void sound_device_set_card_sink_name (SoundDevice* self,
                                      const gchar* value);
void sound_device_set_card_sink_index (SoundDevice* self,
                                       gint value);
void sound_device_set_card_sink_port_name (SoundDevice* self,
                                           const gchar* value);
static void sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_card_info* card,
                                                   gint eol);
static void _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                      pa_card_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                       GeeHashMap* devices,
                                                       guint32 card_index);
static void sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* c,
                                                     pa_source_info* source,
                                                     gint eol);
static void _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                          pa_source_info* i,
                                                                          gint eol,
                                                                          gpointer self);
gint sound_device_get_source_index (SoundDevice* self);
void sound_device_set_source_name (SoundDevice* self,
                                   const gchar* value);
void sound_device_set_source_index (SoundDevice* self,
                                    gint value);
gint sound_device_get_card_source_index (SoundDevice* self);
void sound_device_set_card_source_name (SoundDevice* self,
                                        const gchar* value);
void sound_device_set_card_source_index (SoundDevice* self,
                                         gint value);
void sound_device_set_card_source_port_name (SoundDevice* self,
                                             const gchar* value);
gboolean sound_device_get_is_default (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                                  SoundDevice* value);
static void sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                                   SoundDevice* value);
static void _vala_array_add1 (pa_card_port_info** * array,
                       gint* length,
                       gint* size,
                       pa_card_port_info* value);
static gchar* sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                                pa_card_port_info* port);
SoundDevice* sound_device_new (const gchar* id,
                               guint32 card_index,
                               const gchar* port_name);
SoundDevice* sound_device_construct (GType object_type,
                                     const gchar* id,
                                     guint32 card_index,
                                     const gchar* port_name);
void sound_device_set_card_active_profile_name (SoundDevice* self,
                                                const gchar* value);
void sound_device_set_input (SoundDevice* self,
                             gboolean value);
void sound_device_set_is_priority (SoundDevice* self,
                                   gboolean value);
void sound_device_set_display_name (SoundDevice* self,
                                    const gchar* value);
void sound_device_set_form_factor (SoundDevice* self,
                                   const gchar* value);
const gchar* sound_device_get_form_factor (SoundDevice* self);
void sound_device_set_icon_name (SoundDevice* self,
                                 const gchar* value);
const gchar* sound_device_get_icon_name (SoundDevice* self);
static GeeArrayList* sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                                         pa_card_port_info* port);
void sound_device_set_profiles (SoundDevice* self,
                                GeeArrayList* value);
static void sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                                GeeHashMap* devices,
                                                pa_card_info* card,
                                                pa_card_port_info** relevant_ports,
                                                gint relevant_ports_length1);
static pa_card_profile_info2** _vala_array_dup1 (pa_card_profile_info2** self,
                                          gint length);
static gint __lambda44_ (SoundPulseAudioManager* self,
                  pa_card_profile_info2* a,
                  pa_card_profile_info2* b);
static gint ___lambda44__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                      pa_context* c,
                                                                      pa_ext_stream_restore_info* info,
                                                                      gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                              pa_ext_stream_restore_info* info,
                                                                                                              gint eol,
                                                                                                              gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                        pa_context* c,
                                                                        pa_ext_stream_restore_info* info,
                                                                        gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                                pa_ext_stream_restore_info* info,
                                                                                                                gint eol,
                                                                                                                gpointer self);
static void __lambda43_ (SoundPulseAudioManager* self,
                  pa_context* c,
                  gint success);
static void ___lambda43__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static GObject * sound_pulse_audio_manager_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gint stack_length,
                                      const gchar* needle);
static void sound_pulse_audio_manager_finalize (GObject * obj);
static GType sound_pulse_audio_manager_get_type_once (void);
static void _vala_sound_pulse_audio_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_sound_pulse_audio_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
sound_pulse_audio_manager_get_instance_private (SoundPulseAudioManager* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPulseAudioManager_private_offset);
}

SoundPulseAudioManager*
sound_pulse_audio_manager_get_default (void)
{
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp2_;
	SoundPulseAudioManager* result = NULL;
	_tmp0_ = sound_pulse_audio_manager_pam;
	if (_tmp0_ == NULL) {
		SoundPulseAudioManager* _tmp1_;
		_tmp1_ = sound_pulse_audio_manager_new ();
		_g_object_unref0 (sound_pulse_audio_manager_pam);
		sound_pulse_audio_manager_pam = _tmp1_;
	}
	_tmp2_ = sound_pulse_audio_manager_pam;
	result = _tmp2_;
	return result;
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_construct (GType object_type)
{
	SoundPulseAudioManager * self = NULL;
	self = (SoundPulseAudioManager*) g_object_new (object_type, NULL);
	return self;
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_new (void)
{
	return sound_pulse_audio_manager_construct (SOUND_TYPE_PULSE_AUDIO_MANAGER);
}

void
sound_pulse_audio_manager_start (SoundPulseAudioManager* self)
{
	g_return_if_fail (self != NULL);
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
}

static void
sound_pulse_audio_manager_set_default_device_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->device);
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetDefaultDeviceData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultDeviceData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_device_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (device);
	_g_object_unref0 (_data_->device);
	_data_->device = _tmp1_;
	sound_pulse_audio_manager_set_default_device_co (_data_);
}

void
sound_pulse_audio_manager_set_default_device_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	sound_pulse_audio_manager_set_default_device_co (_data_);
}

static gboolean
sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		case 4:
		goto _state_4;
		case 5:
		goto _state_5;
		case 6:
		goto _state_6;
		case 7:
		goto _state_7;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	g_debug ("PulseAudioManager.vala:75: \n");
	_data_->_tmp0_ = sound_device_get_id (_data_->device);
	_data_->_tmp1_ = _data_->_tmp0_;
	g_debug ("PulseAudioManager.vala:76: set_default_device: %s", _data_->_tmp1_);
	_data_->_tmp3_ = sound_device_get_input (_data_->device);
	_data_->_tmp4_ = _data_->_tmp3_;
	if (_data_->_tmp4_) {
		_data_->_tmp2_ = "input";
	} else {
		_data_->_tmp2_ = "output";
	}
	g_debug ("PulseAudioManager.vala:77: \t%s", _data_->_tmp2_);
	_data_->_tmp6_ = sound_device_get_input (_data_->device);
	_data_->_tmp7_ = _data_->_tmp6_;
	if (_data_->_tmp7_) {
		_data_->_tmp8_ = _data_->self->priv->_default_output;
		_data_->_tmp5_ = _data_->_tmp8_;
	} else {
		_data_->_tmp9_ = _data_->self->priv->_default_input;
		_data_->_tmp5_ = _data_->_tmp9_;
	}
	_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp5_);
	_data_->other_device = _data_->_tmp10_;
	_data_->_tmp11_ = _data_->other_device;
	_data_->_tmp12_ = sound_device_get_matching_profile (_data_->device, _data_->_tmp11_);
	_data_->profile_name = _data_->_tmp12_;
	_data_->_tmp13_ = _data_->profile_name;
	if (_data_->_tmp13_ == NULL) {
		_data_->_tmp14_ = sound_device_get_profiles (_data_->device);
		_data_->_tmp15_ = _data_->_tmp14_;
		_data_->_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp15_, 0);
		_g_free0 (_data_->profile_name);
		_data_->profile_name = (gchar*) _data_->_tmp16_;
	}
	_data_->_tmp17_ = _data_->profile_name;
	_data_->_tmp18_ = sound_device_get_card_active_profile_name (_data_->device);
	_data_->_tmp19_ = _data_->_tmp18_;
	if (g_strcmp0 (_data_->_tmp17_, _data_->_tmp19_) != 0) {
		_data_->_tmp20_ = sound_device_get_card_active_profile_name (_data_->device);
		_data_->_tmp21_ = _data_->_tmp20_;
		_data_->_tmp22_ = _data_->profile_name;
		g_debug ("PulseAudioManager.vala:92: set card profile: %s > %s", _data_->_tmp21_, _data_->_tmp22_);
		_data_->_tmp23_ = sound_device_get_card_index (_data_->device);
		_data_->_tmp24_ = _data_->_tmp23_;
		_data_->_tmp25_ = _data_->profile_name;
		_data_->_state_ = 1;
		sound_pulse_audio_manager_set_card_profile_by_index (_data_->self, _data_->_tmp24_, _data_->_tmp25_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_1:
		sound_pulse_audio_manager_set_card_profile_by_index_finish (_data_->self, _data_->_res_);
		g_debug ("PulseAudioManager.vala:96: wait for card sink / source");
		_data_->_tmp27_ = sound_device_get_input (_data_->device);
		_data_->_tmp28_ = _data_->_tmp27_;
		if (_data_->_tmp28_) {
			_data_->_tmp26_ = "card-source-name";
		} else {
			_data_->_tmp26_ = "card-sink-name";
		}
		_data_->_state_ = 2;
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp26_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_2:
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp30_ = sound_device_get_input (_data_->device);
	_data_->_tmp31_ = _data_->_tmp30_;
	if (!_data_->_tmp31_) {
		_data_->_tmp32_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp33_ = _data_->_tmp32_;
		_data_->_tmp34_ = sound_device_get_card_sink_port_name (_data_->device);
		_data_->_tmp35_ = _data_->_tmp34_;
		_data_->_tmp29_ = g_strcmp0 (_data_->_tmp33_, _data_->_tmp35_) != 0;
	} else {
		_data_->_tmp29_ = FALSE;
	}
	if (_data_->_tmp29_) {
		_data_->_tmp36_ = sound_device_get_card_sink_port_name (_data_->device);
		_data_->_tmp37_ = _data_->_tmp36_;
		_data_->_tmp38_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp39_ = _data_->_tmp38_;
		g_debug ("PulseAudioManager.vala:103: set sink port: %s > %s", _data_->_tmp37_, _data_->_tmp39_);
		_data_->_tmp40_ = sound_device_get_card_sink_name (_data_->device);
		_data_->_tmp41_ = _data_->_tmp40_;
		_data_->_tmp42_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp43_ = _data_->_tmp42_;
		_data_->_state_ = 3;
		sound_pulse_audio_manager_set_sink_port_by_name (_data_->self, _data_->_tmp41_, _data_->_tmp43_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_3:
		sound_pulse_audio_manager_set_sink_port_by_name_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp45_ = sound_device_get_input (_data_->device);
	_data_->_tmp46_ = _data_->_tmp45_;
	if (_data_->_tmp46_) {
		_data_->_tmp47_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp48_ = _data_->_tmp47_;
		_data_->_tmp49_ = sound_device_get_card_source_port_name (_data_->device);
		_data_->_tmp50_ = _data_->_tmp49_;
		_data_->_tmp44_ = g_strcmp0 (_data_->_tmp48_, _data_->_tmp50_) != 0;
	} else {
		_data_->_tmp44_ = FALSE;
	}
	if (_data_->_tmp44_) {
		_data_->_tmp51_ = sound_device_get_card_source_port_name (_data_->device);
		_data_->_tmp52_ = _data_->_tmp51_;
		_data_->_tmp53_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp54_ = _data_->_tmp53_;
		g_debug ("PulseAudioManager.vala:109: set source port: %s > %s", _data_->_tmp52_, _data_->_tmp54_);
		_data_->_tmp55_ = sound_device_get_card_source_name (_data_->device);
		_data_->_tmp56_ = _data_->_tmp55_;
		_data_->_tmp57_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp58_ = _data_->_tmp57_;
		_data_->_state_ = 4;
		sound_pulse_audio_manager_set_source_port_by_name (_data_->self, _data_->_tmp56_, _data_->_tmp58_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_4:
		sound_pulse_audio_manager_set_source_port_by_name_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp61_ = sound_device_get_input (_data_->device);
	_data_->_tmp62_ = _data_->_tmp61_;
	if (!_data_->_tmp62_) {
		_data_->_tmp63_ = sound_device_get_sink_name (_data_->device);
		_data_->_tmp64_ = _data_->_tmp63_;
		_data_->_tmp60_ = _data_->_tmp64_ == NULL;
	} else {
		_data_->_tmp60_ = FALSE;
	}
	if (_data_->_tmp60_) {
		_data_->_tmp59_ = TRUE;
	} else {
		_data_->_tmp66_ = sound_device_get_input (_data_->device);
		_data_->_tmp67_ = _data_->_tmp66_;
		if (_data_->_tmp67_) {
			_data_->_tmp68_ = sound_device_get_source_name (_data_->device);
			_data_->_tmp69_ = _data_->_tmp68_;
			_data_->_tmp65_ = _data_->_tmp69_ == NULL;
		} else {
			_data_->_tmp65_ = FALSE;
		}
		_data_->_tmp59_ = _data_->_tmp65_;
	}
	if (_data_->_tmp59_) {
		g_debug ("PulseAudioManager.vala:116: wait for sink / source");
		_data_->_tmp71_ = sound_device_get_input (_data_->device);
		_data_->_tmp72_ = _data_->_tmp71_;
		if (_data_->_tmp72_) {
			_data_->_tmp70_ = "source-name";
		} else {
			_data_->_tmp70_ = "sink-name";
		}
		_data_->_state_ = 5;
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp70_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_5:
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp74_ = sound_device_get_input (_data_->device);
	_data_->_tmp75_ = _data_->_tmp74_;
	if (!_data_->_tmp75_) {
		_data_->_tmp76_ = sound_device_get_sink_name (_data_->device);
		_data_->_tmp77_ = _data_->_tmp76_;
		_data_->_tmp78_ = _data_->self->priv->default_sink_name;
		_data_->_tmp73_ = g_strcmp0 (_data_->_tmp77_, _data_->_tmp78_) != 0;
	} else {
		_data_->_tmp73_ = FALSE;
	}
	if (_data_->_tmp73_) {
		_data_->_tmp79_ = _data_->self->priv->default_sink_name;
		_data_->_tmp80_ = sound_device_get_sink_name (_data_->device);
		_data_->_tmp81_ = _data_->_tmp80_;
		g_debug ("PulseAudioManager.vala:123: set sink: %s > %s", _data_->_tmp79_, _data_->_tmp81_);
		_data_->_tmp82_ = sound_device_get_sink_name (_data_->device);
		_data_->_tmp83_ = _data_->_tmp82_;
		_data_->_state_ = 6;
		sound_pulse_audio_manager_set_default_sink (_data_->self, _data_->_tmp83_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_6:
		sound_pulse_audio_manager_set_default_sink_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp85_ = sound_device_get_input (_data_->device);
	_data_->_tmp86_ = _data_->_tmp85_;
	if (_data_->_tmp86_) {
		_data_->_tmp87_ = sound_device_get_source_name (_data_->device);
		_data_->_tmp88_ = _data_->_tmp87_;
		_data_->_tmp89_ = _data_->self->priv->default_source_name;
		_data_->_tmp84_ = g_strcmp0 (_data_->_tmp88_, _data_->_tmp89_) != 0;
	} else {
		_data_->_tmp84_ = FALSE;
	}
	if (_data_->_tmp84_) {
		_data_->_tmp90_ = _data_->self->priv->default_source_name;
		_data_->_tmp91_ = sound_device_get_source_name (_data_->device);
		_data_->_tmp92_ = _data_->_tmp91_;
		g_debug ("PulseAudioManager.vala:128: set source: %s > %s", _data_->_tmp90_, _data_->_tmp92_);
		_data_->_tmp93_ = sound_device_get_source_name (_data_->device);
		_data_->_tmp94_ = _data_->_tmp93_;
		_data_->_state_ = 7;
		sound_pulse_audio_manager_set_default_source (_data_->self, _data_->_tmp94_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_7:
		sound_pulse_audio_manager_set_default_source_finish (_data_->self, _data_->_res_);
	}
	_g_free0 (_data_->profile_name);
	_g_object_unref0 (_data_->other_device);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetCardProfileByIndexData, _data_);
}

static void
sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                     guint32 card_index,
                                                     const gchar* profile_name,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetCardProfileByIndexData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_card_profile_by_index_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->card_index = card_index;
	_tmp1_ = g_strdup (profile_name);
	_g_free0 (_data_->profile_name);
	_data_->profile_name = _tmp1_;
	sound_pulse_audio_manager_set_card_profile_by_index_co (_data_);
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                            GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data6_->self;
		_g_free0 (_data6_->profile_name);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static void
__lambda45_ (Block6Data* _data6_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
	self = _data6_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_card_profile_by_index_co (_data6_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:138: setting card %u profile to %s failed", (guint) _data6_->card_index, _data6_->profile_name);
	}
}

static void
___lambda45__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda45_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data6_ = g_slice_new0 (Block6Data);
	_data_->_data6_->_ref_count_ = 1;
	_data_->_data6_->self = g_object_ref (_data_->self);
	_data_->_data6_->card_index = _data_->card_index;
	_g_free0 (_data_->_data6_->profile_name);
	_data_->_data6_->profile_name = _data_->profile_name;
	_data_->_data6_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->context;
	_data_->_tmp1_ = pa_context_set_card_profile_by_index (_data_->_tmp0_, _data_->_data6_->card_index, _data_->_data6_->profile_name, ___lambda45__pa_context_success_cb_t, _data_->_data6_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block6_data_unref (_data_->_data6_);
	_data_->_data6_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerWaitForUpdateData, _data_);
}

static void
sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                           SoundDevice* device,
                                           const gchar* prop_name,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerWaitForUpdateData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_wait_for_update_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (device);
	_g_object_unref0 (_data_->device);
	_data_->device = _tmp1_;
	_tmp2_ = g_strdup (prop_name);
	_g_free0 (_data_->prop_name);
	_data_->prop_name = _tmp2_;
	sound_pulse_audio_manager_wait_for_update_co (_data_);
}

static void
sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                  GAsyncResult* _res_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->device);
		_g_free0 (_data7_->prop_name);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
__lambda46_ (Block7Data* _data7_,
             GObject* s,
             GParamSpec* p)
{
	SoundPulseAudioManager* self;
	gchar* prop_value = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	self = _data7_->self;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	g_object_get ((GObject*) _data7_->device, _data7_->prop_name, &_tmp0_, NULL);
	_g_free0 (prop_value);
	prop_value = _tmp0_;
	_tmp1_ = prop_value;
	if (_tmp1_ != NULL) {
		g_signal_handler_disconnect ((GObject*) _data7_->device, _data7_->handler_id);
		sound_pulse_audio_manager_wait_for_update_co (_data7_->_async_data_);
	}
	_g_free0 (prop_value);
}

static void
___lambda46__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda46_ (self, _sender, pspec);
}

static gboolean
sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data7_ = g_slice_new0 (Block7Data);
	_data_->_data7_->_ref_count_ = 1;
	_data_->_data7_->self = g_object_ref (_data_->self);
	_g_object_unref0 (_data_->_data7_->device);
	_data_->_data7_->device = _data_->device;
	_g_free0 (_data_->_data7_->prop_name);
	_data_->_data7_->prop_name = _data_->prop_name;
	_data_->_data7_->_async_data_ = _data_;
	_data_->_tmp0_ = sound_device_get_id (_data_->_data7_->device);
	_data_->_tmp1_ = _data_->_tmp0_;
	g_debug ("PulseAudioManager.vala:147: wait_for_update: %s:%s", _data_->_tmp1_, _data_->_data7_->prop_name);
	_data_->_data7_->handler_id = (gulong) 0;
	_data_->_tmp2_ = g_strconcat ("notify::", _data_->_data7_->prop_name, NULL);
	_data_->_tmp3_ = g_signal_connect_data ((GObject*) _data_->_data7_->device, _data_->_tmp2_, (GCallback) ___lambda46__g_object_notify, block7_data_ref (_data_->_data7_), (GClosureNotify) block7_data_unref, 0);
	_data_->_data7_->handler_id = _data_->_tmp3_;
	_g_free0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block7_data_unref (_data_->_data7_);
	_data_->_data7_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetSinkPortByNameData, _data_);
}

static void
sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 const gchar* port_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSinkPortByNameData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_sink_port_by_name_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (sink_name);
	_g_free0 (_data_->sink_name);
	_data_->sink_name = _tmp1_;
	_tmp2_ = g_strdup (port_name);
	_g_free0 (_data_->port_name);
	_data_->port_name = _tmp2_;
	sound_pulse_audio_manager_set_sink_port_by_name_co (_data_);
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data8_->self;
		_g_free0 (_data8_->sink_name);
		_g_free0 (_data8_->port_name);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static void
__lambda47_ (Block8Data* _data8_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
	self = _data8_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_sink_port_by_name_co (_data8_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:166: setting sink %s port to %s failed", _data8_->sink_name, _data8_->port_name);
	}
}

static void
___lambda47__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda47_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data8_ = g_slice_new0 (Block8Data);
	_data_->_data8_->_ref_count_ = 1;
	_data_->_data8_->self = g_object_ref (_data_->self);
	_g_free0 (_data_->_data8_->sink_name);
	_data_->_data8_->sink_name = _data_->sink_name;
	_g_free0 (_data_->_data8_->port_name);
	_data_->_data8_->port_name = _data_->port_name;
	_data_->_data8_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->context;
	_data_->_tmp1_ = pa_context_set_sink_port_by_name (_data_->_tmp0_, _data_->_data8_->sink_name, _data_->_data8_->port_name, ___lambda47__pa_context_success_cb_t, _data_->_data8_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block8_data_unref (_data_->_data8_);
	_data_->_data8_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetSourcePortByNameData, _data_);
}

static void
sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   const gchar* port_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSourcePortByNameData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_source_port_by_name_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (source_name);
	_g_free0 (_data_->source_name);
	_data_->source_name = _tmp1_;
	_tmp2_ = g_strdup (port_name);
	_g_free0 (_data_->port_name);
	_data_->port_name = _tmp2_;
	sound_pulse_audio_manager_set_source_port_by_name_co (_data_);
}

static void
sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data9_->self;
		_g_free0 (_data9_->source_name);
		_g_free0 (_data9_->port_name);
		_g_object_unref0 (self);
		g_slice_free (Block9Data, _data9_);
	}
}

static void
__lambda48_ (Block9Data* _data9_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
	self = _data9_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_source_port_by_name_co (_data9_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:178: setting source %s port to %s failed", _data9_->source_name, _data9_->port_name);
	}
}

static void
___lambda48__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda48_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data9_ = g_slice_new0 (Block9Data);
	_data_->_data9_->_ref_count_ = 1;
	_data_->_data9_->self = g_object_ref (_data_->self);
	_g_free0 (_data_->_data9_->source_name);
	_data_->_data9_->source_name = _data_->source_name;
	_g_free0 (_data_->_data9_->port_name);
	_data_->_data9_->port_name = _data_->port_name;
	_data_->_data9_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->context;
	_data_->_tmp1_ = pa_context_set_source_port_by_name (_data_->_tmp0_, _data_->_data9_->source_name, _data_->_data9_->port_name, ___lambda48__pa_context_success_cb_t, _data_->_data9_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block9_data_unref (_data_->_data9_);
	_data_->_data9_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetDefaultSinkData, _data_);
}

static void
sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                            const gchar* sink_name,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSinkData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_sink_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (sink_name);
	_g_free0 (_data_->sink_name);
	_data_->sink_name = _tmp1_;
	sound_pulse_audio_manager_set_default_sink_co (_data_);
}

static void
sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                   GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data10_->self;
		_g_free0 (_data10_->sink_name);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static void
__lambda49_ (Block10Data* _data10_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
	self = _data10_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_default_sink_co (_data10_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:190: setting default sink to %s failed", _data10_->sink_name);
	}
}

static void
___lambda49__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda49_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data10_ = g_slice_new0 (Block10Data);
	_data_->_data10_->_ref_count_ = 1;
	_data_->_data10_->self = g_object_ref (_data_->self);
	_g_free0 (_data_->_data10_->sink_name);
	_data_->_data10_->sink_name = _data_->sink_name;
	_data_->_data10_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->context;
	_data_->_tmp1_ = pa_context_set_default_sink (_data_->_tmp0_, _data_->_data10_->sink_name, ___lambda49__pa_context_success_cb_t, _data_->_data10_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block10_data_unref (_data_->_data10_);
	_data_->_data10_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_default_source_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetDefaultSourceData, _data_);
}

static void
sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                              const gchar* source_name,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSourceData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_source_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (source_name);
	_g_free0 (_data_->source_name);
	_data_->source_name = _tmp1_;
	sound_pulse_audio_manager_set_default_source_co (_data_);
}

static void
sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data11_->self;
		_g_free0 (_data11_->source_name);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}

static void
__lambda50_ (Block11Data* _data11_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
	self = _data11_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_default_source_co (_data11_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:202: setting default source to %s failed", _data11_->source_name);
	}
}

static void
___lambda50__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda50_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data11_ = g_slice_new0 (Block11Data);
	_data_->_data11_->_ref_count_ = 1;
	_data_->_data11_->self = g_object_ref (_data_->self);
	_g_free0 (_data_->_data11_->source_name);
	_data_->_data11_->source_name = _data_->source_name;
	_data_->_data11_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->context;
	_data_->_tmp1_ = pa_context_set_default_source (_data_->_tmp0_, _data_->_data11_->source_name, ___lambda50__pa_context_success_cb_t, _data_->_data11_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block11_data_unref (_data_->_data11_);
	_data_->_data11_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gboolean
sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->reconnect_timer_id = 0U;
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
	result = FALSE;
	return result;
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerReconnectToPulseData, _data_);
}

static void
sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	SoundPulseAudioManager* _tmp0_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerReconnectToPulseData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_reconnect_to_pulse_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	sound_pulse_audio_manager_reconnect_to_pulse_co (_data_);
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
_sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                          gpointer self)
{
	sound_pulse_audio_manager_context_state_callback ((SoundPulseAudioManager*) self, c);
}

static gboolean
sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (_data_->self->priv->is_ready) {
		_data_->_tmp0_ = _data_->self->priv->context;
		pa_context_disconnect (_data_->_tmp0_);
		_pa_context_unref0 (_data_->self->priv->context);
		_data_->self->priv->context = NULL;
		_data_->self->priv->is_ready = FALSE;
	}
	_data_->_tmp1_ = pa_proplist_new ();
	_data_->props = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->props;
	pa_proplist_sets (_data_->_tmp2_, PA_PROP_APPLICATION_ID, "org.wingpanel.indicator.sound");
	_data_->_tmp3_ = _data_->self->priv->loop;
	_data_->_tmp4_ = pa_glib_mainloop_get_api (_data_->_tmp3_);
	_data_->_tmp5_ = _data_->props;
	_data_->_tmp6_ = pa_context_new_with_proplist (_data_->_tmp4_, NULL, _data_->_tmp5_);
	_pa_context_unref0 (_data_->self->priv->context);
	_data_->self->priv->context = _data_->_tmp6_;
	_data_->_tmp7_ = _data_->self->priv->context;
	pa_context_set_state_callback (_data_->_tmp7_, _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t, _data_->self);
	_data_->_tmp8_ = _data_->self->priv->context;
	if (pa_context_connect (_data_->_tmp8_, NULL, PA_CONTEXT_NOFAIL, NULL) < 0) {
		_data_->_tmp9_ = _data_->self->priv->context;
		_data_->_tmp10_ = pa_strerror (pa_context_errno (_data_->_tmp9_));
		g_warning ("PulseAudioManager.vala:232: pa_context_connect () failed: %s\n", _data_->_tmp10_);
	}
	_pa_proplist_free0 (_data_->props);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
_sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                         pa_subscription_event_type_t t,
                                                                         guint32 idx,
                                                                         gpointer self)
{
	sound_pulse_audio_manager_subscribe_callback ((SoundPulseAudioManager*) self, c, t, idx);
}

static void
_sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                     pa_server_info* i,
                                                                     gpointer self)
{
	sound_pulse_audio_manager_server_info_callback ((SoundPulseAudioManager*) self, c, i);
}

static gboolean
_sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = sound_pulse_audio_manager_reconnect_timeout ((SoundPulseAudioManager*) self);
	return result;
}

static void
sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                  pa_context* c)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	switch (pa_context_get_state (c)) {
		case PA_CONTEXT_READY:
		{
			pa_operation* _tmp0_;
			pa_operation* _tmp1_;
			pa_context* _tmp2_;
			pa_operation* _tmp3_;
			pa_operation* _tmp4_;
			pa_context_set_subscribe_callback (c, _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t, self);
			_tmp0_ = pa_context_subscribe (c, ((((PA_SUBSCRIPTION_MASK_SERVER | PA_SUBSCRIPTION_MASK_SINK) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT) | PA_SUBSCRIPTION_MASK_CARD, NULL, NULL);
			_tmp1_ = _tmp0_;
			_pa_operation_unref0 (_tmp1_);
			_tmp2_ = self->priv->context;
			_tmp3_ = pa_context_get_server_info (_tmp2_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
			_tmp4_ = _tmp3_;
			_pa_operation_unref0 (_tmp4_);
			self->priv->is_ready = TRUE;
			break;
		}
		case PA_CONTEXT_FAILED:
		case PA_CONTEXT_TERMINATED:
		{
			if (self->priv->reconnect_timer_id == 0U) {
				self->priv->reconnect_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _sound_pulse_audio_manager_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
			}
			break;
		}
		default:
		{
			self->priv->is_ready = FALSE;
			break;
		}
	}
}

static void
_sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                 pa_sink_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
	sound_pulse_audio_manager_sink_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}

static void
_sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                 pa_card_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
	sound_pulse_audio_manager_card_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}

static void
_sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                     pa_source_info* i,
                                                                     gint eol,
                                                                     gpointer self)
{
	sound_pulse_audio_manager_source_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}

static void
sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_subscription_event_type_t t,
                                              guint32 index)
{
	pa_subscription_event_type_t source_type = 0;
	pa_subscription_event_type_t _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	source_type = t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK;
	_tmp0_ = source_type;
	switch (_tmp0_) {
		case PA_SUBSCRIPTION_EVENT_SINK:
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp1_;
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp1_ = event_type;
			switch (_tmp1_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp2_;
					pa_operation* _tmp3_;
					_tmp2_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
					_tmp3_ = _tmp2_;
					_pa_operation_unref0 (_tmp3_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_operation* _tmp4_;
					pa_operation* _tmp5_;
					_tmp4_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
					_tmp5_ = _tmp4_;
					_pa_operation_unref0 (_tmp5_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					g_debug ("PulseAudioManager.vala:284: subscribe_callback:SINK:REMOVE");
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp6_;
						GeeCollection* _tmp7_;
						GeeCollection* _tmp8_;
						GeeCollection* _tmp9_;
						GeeIterator* _tmp10_;
						GeeIterator* _tmp11_;
						_tmp6_ = self->priv->output_devices;
						_tmp7_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp6_);
						_tmp8_ = _tmp7_;
						_tmp9_ = _tmp8_;
						_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
						_tmp11_ = _tmp10_;
						_g_object_unref0 (_tmp9_);
						_device_it = _tmp11_;
						while (TRUE) {
							GeeIterator* _tmp12_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp13_;
							gpointer _tmp14_;
							SoundDevice* _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							SoundDevice* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							_tmp12_ = _device_it;
							if (!gee_iterator_next (_tmp12_)) {
								break;
							}
							_tmp13_ = _device_it;
							_tmp14_ = gee_iterator_get (_tmp13_);
							device = (SoundDevice*) _tmp14_;
							_tmp15_ = device;
							_tmp16_ = sound_device_get_sink_index (_tmp15_);
							_tmp17_ = _tmp16_;
							if (((guint32) _tmp17_) == index) {
								SoundDevice* _tmp18_;
								const gchar* _tmp19_;
								const gchar* _tmp20_;
								SoundDevice* _tmp21_;
								SoundDevice* _tmp22_;
								SoundDevice* _tmp23_;
								SoundDevice* _tmp24_;
								const gchar* _tmp25_;
								const gchar* _tmp26_;
								_tmp18_ = device;
								_tmp19_ = sound_device_get_id (_tmp18_);
								_tmp20_ = _tmp19_;
								g_debug ("PulseAudioManager.vala:287: \tupdating device: %s", _tmp20_);
								_tmp21_ = device;
								sound_device_set_sink_name (_tmp21_, NULL);
								_tmp22_ = device;
								sound_device_set_sink_index (_tmp22_, -1);
								_tmp23_ = device;
								sound_device_set_is_default (_tmp23_, FALSE);
								_tmp24_ = device;
								_tmp25_ = sound_device_get_sink_name (_tmp24_);
								_tmp26_ = _tmp25_;
								g_debug ("PulseAudioManager.vala:291: \t\tdevice.sink_name: %s", _tmp26_);
							}
							_tmp27_ = device;
							_tmp28_ = sound_device_get_card_sink_index (_tmp27_);
							_tmp29_ = _tmp28_;
							if (((guint32) _tmp29_) == index) {
								SoundDevice* _tmp30_;
								const gchar* _tmp31_;
								const gchar* _tmp32_;
								SoundDevice* _tmp33_;
								SoundDevice* _tmp34_;
								SoundDevice* _tmp35_;
								SoundDevice* _tmp36_;
								const gchar* _tmp37_;
								const gchar* _tmp38_;
								_tmp30_ = device;
								_tmp31_ = sound_device_get_id (_tmp30_);
								_tmp32_ = _tmp31_;
								g_debug ("PulseAudioManager.vala:295: \tupdating device: %s", _tmp32_);
								_tmp33_ = device;
								sound_device_set_card_sink_name (_tmp33_, NULL);
								_tmp34_ = device;
								sound_device_set_card_sink_index (_tmp34_, -1);
								_tmp35_ = device;
								sound_device_set_card_sink_port_name (_tmp35_, NULL);
								_tmp36_ = device;
								_tmp37_ = sound_device_get_card_sink_name (_tmp36_);
								_tmp38_ = _tmp37_;
								g_debug ("PulseAudioManager.vala:299: \t\tdevice.card_sink_name: %s", _tmp38_);
							}
							_g_object_unref0 (device);
						}
						_g_object_unref0 (_device_it);
					}
					break;
				}
				default:
				break;
			}
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SERVER:
		{
			pa_context* _tmp39_;
			pa_operation* _tmp40_;
			pa_operation* _tmp41_;
			_tmp39_ = self->priv->context;
			_tmp40_ = pa_context_get_server_info (_tmp39_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
			_tmp41_ = _tmp40_;
			_pa_operation_unref0 (_tmp41_);
			break;
		}
		case PA_SUBSCRIPTION_EVENT_CARD:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp42_;
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp42_ = event_type;
			switch (_tmp42_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp43_;
					pa_operation* _tmp44_;
					_tmp43_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
					_tmp44_ = _tmp43_;
					_pa_operation_unref0 (_tmp44_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_operation* _tmp45_;
					pa_operation* _tmp46_;
					_tmp45_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
					_tmp46_ = _tmp45_;
					_pa_operation_unref0 (_tmp46_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					GeeHashMap* _tmp47_;
					GeeHashMap* _tmp48_;
					_tmp47_ = self->priv->output_devices;
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp47_, index);
					_tmp48_ = self->priv->input_devices;
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp48_, index);
					break;
				}
				default:
				break;
			}
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SOURCE:
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp49_;
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp49_ = event_type;
			switch (_tmp49_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp50_;
					pa_operation* _tmp51_;
					_tmp50_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
					_tmp51_ = _tmp50_;
					_pa_operation_unref0 (_tmp51_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_operation* _tmp52_;
					pa_operation* _tmp53_;
					_tmp52_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
					_tmp53_ = _tmp52_;
					_pa_operation_unref0 (_tmp53_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					g_debug ("PulseAudioManager.vala:344: subscribe_callback:SOURCE:REMOVE");
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp54_;
						GeeCollection* _tmp55_;
						GeeCollection* _tmp56_;
						GeeCollection* _tmp57_;
						GeeIterator* _tmp58_;
						GeeIterator* _tmp59_;
						_tmp54_ = self->priv->input_devices;
						_tmp55_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp54_);
						_tmp56_ = _tmp55_;
						_tmp57_ = _tmp56_;
						_tmp58_ = gee_iterable_iterator ((GeeIterable*) _tmp57_);
						_tmp59_ = _tmp58_;
						_g_object_unref0 (_tmp57_);
						_device_it = _tmp59_;
						while (TRUE) {
							GeeIterator* _tmp60_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp61_;
							gpointer _tmp62_;
							SoundDevice* _tmp63_;
							gint _tmp64_;
							gint _tmp65_;
							SoundDevice* _tmp75_;
							gint _tmp76_;
							gint _tmp77_;
							_tmp60_ = _device_it;
							if (!gee_iterator_next (_tmp60_)) {
								break;
							}
							_tmp61_ = _device_it;
							_tmp62_ = gee_iterator_get (_tmp61_);
							device = (SoundDevice*) _tmp62_;
							_tmp63_ = device;
							_tmp64_ = sound_device_get_source_index (_tmp63_);
							_tmp65_ = _tmp64_;
							if (((guint32) _tmp65_) == index) {
								SoundDevice* _tmp66_;
								const gchar* _tmp67_;
								const gchar* _tmp68_;
								SoundDevice* _tmp69_;
								SoundDevice* _tmp70_;
								SoundDevice* _tmp71_;
								SoundDevice* _tmp72_;
								const gchar* _tmp73_;
								const gchar* _tmp74_;
								_tmp66_ = device;
								_tmp67_ = sound_device_get_id (_tmp66_);
								_tmp68_ = _tmp67_;
								g_debug ("PulseAudioManager.vala:347: \tupdating device: %s", _tmp68_);
								_tmp69_ = device;
								sound_device_set_source_name (_tmp69_, NULL);
								_tmp70_ = device;
								sound_device_set_source_index (_tmp70_, -1);
								_tmp71_ = device;
								sound_device_set_is_default (_tmp71_, FALSE);
								_tmp72_ = device;
								_tmp73_ = sound_device_get_source_name (_tmp72_);
								_tmp74_ = _tmp73_;
								g_debug ("PulseAudioManager.vala:351: \t\tdevice.source_name: %s", _tmp74_);
							}
							_tmp75_ = device;
							_tmp76_ = sound_device_get_card_source_index (_tmp75_);
							_tmp77_ = _tmp76_;
							if (((guint32) _tmp77_) == index) {
								SoundDevice* _tmp78_;
								const gchar* _tmp79_;
								const gchar* _tmp80_;
								SoundDevice* _tmp81_;
								SoundDevice* _tmp82_;
								SoundDevice* _tmp83_;
								SoundDevice* _tmp84_;
								const gchar* _tmp85_;
								const gchar* _tmp86_;
								_tmp78_ = device;
								_tmp79_ = sound_device_get_id (_tmp78_);
								_tmp80_ = _tmp79_;
								g_debug ("PulseAudioManager.vala:355: \tupdating device: %s", _tmp80_);
								_tmp81_ = device;
								sound_device_set_card_source_name (_tmp81_, NULL);
								_tmp82_ = device;
								sound_device_set_card_source_index (_tmp82_, -1);
								_tmp83_ = device;
								sound_device_set_card_source_port_name (_tmp83_, NULL);
								_tmp84_ = device;
								_tmp85_ = sound_device_get_card_source_name (_tmp84_);
								_tmp86_ = _tmp85_;
								g_debug ("PulseAudioManager.vala:359: \t\tdevice.card_source_name: %s", _tmp86_);
							}
							_g_object_unref0 (device);
						}
						_g_object_unref0 (_device_it);
					}
					break;
				}
				default:
				break;
			}
			break;
		}
		default:
		break;
	}
}

static void
sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                pa_context* c,
                                                pa_source_info* source,
                                                gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_source_port_info* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (source == NULL) {
		return;
	}
	if ((*source).monitor_of_sink != PA_INVALID_INDEX) {
		return;
	}
	g_debug ("PulseAudioManager.vala:384: source info update");
	_tmp0_ = (*source).description;
	_tmp1_ = (*source).name;
	g_debug ("PulseAudioManager.vala:385: \tsource: %s (%s)", _tmp0_, _tmp1_);
	g_debug ("PulseAudioManager.vala:386: \t\tcard: %u", (guint) (*source).card);
	_tmp2_ = (*source).name;
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
		return;
	}
	if (sound_pulse_audio_manager_debug_enabled) {
		pa_source_port_info** _tmp3_;
		gint _tmp3__length1;
		_tmp3_ = (*source).ports;
		_tmp3__length1 = (*source).n_ports;
		{
			pa_source_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
			port_collection = _tmp3_;
			port_collection_length1 = _tmp3__length1;
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
				pa_source_port_info* port = NULL;
				port = port_collection[port_it];
				{
					pa_source_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_source_port_info* _tmp6_;
					const gchar* _tmp7_;
					_tmp4_ = port;
					_tmp5_ = (*_tmp4_).description;
					_tmp6_ = port;
					_tmp7_ = (*_tmp6_).name;
					g_debug ("PulseAudioManager.vala:394: \t\tport: %s (%s)", _tmp5_, _tmp7_);
				}
			}
		}
	}
	_tmp8_ = (*source).active_port;
	if (_tmp8_ != NULL) {
		pa_source_port_info* _tmp9_;
		const gchar* _tmp10_;
		pa_source_port_info* _tmp11_;
		const gchar* _tmp12_;
		_tmp9_ = (*source).active_port;
		_tmp10_ = (*_tmp9_).description;
		_tmp11_ = (*source).active_port;
		_tmp12_ = (*_tmp11_).name;
		g_debug ("PulseAudioManager.vala:399: \t\tactive port: %s (%s)", _tmp10_, _tmp12_);
	}
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
		_tmp13_ = self->priv->input_devices;
		_tmp14_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = _tmp15_;
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
		_tmp18_ = _tmp17_;
		_g_object_unref0 (_tmp16_);
		_device_it = _tmp18_;
		while (TRUE) {
			GeeIterator* _tmp19_;
			SoundDevice* device = NULL;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			SoundDevice* _tmp22_;
			guint32 _tmp23_;
			guint32 _tmp24_;
			_tmp19_ = _device_it;
			if (!gee_iterator_next (_tmp19_)) {
				break;
			}
			_tmp20_ = _device_it;
			_tmp21_ = gee_iterator_get (_tmp20_);
			device = (SoundDevice*) _tmp21_;
			_tmp22_ = device;
			_tmp23_ = sound_device_get_card_index (_tmp22_);
			_tmp24_ = _tmp23_;
			if (_tmp24_ == (*source).card) {
				SoundDevice* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SoundDevice* _tmp28_;
				SoundDevice* _tmp29_;
				const gchar* _tmp30_;
				SoundDevice* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gboolean _tmp34_ = FALSE;
				pa_source_port_info* _tmp35_;
				_tmp25_ = device;
				_tmp26_ = sound_device_get_id (_tmp25_);
				_tmp27_ = _tmp26_;
				g_debug ("PulseAudioManager.vala:404: \t\tupdating device: %s", _tmp27_);
				_tmp28_ = device;
				sound_device_set_card_source_index (_tmp28_, (gint) (*source).index);
				_tmp29_ = device;
				_tmp30_ = (*source).name;
				sound_device_set_card_source_name (_tmp29_, _tmp30_);
				_tmp31_ = device;
				_tmp32_ = sound_device_get_card_source_name (_tmp31_);
				_tmp33_ = _tmp32_;
				g_debug ("PulseAudioManager.vala:407: \t\t\tdevice.card_source_name: %s", _tmp33_);
				_tmp35_ = (*source).active_port;
				if (_tmp35_ != NULL) {
					SoundDevice* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					pa_source_port_info* _tmp39_;
					const gchar* _tmp40_;
					_tmp36_ = device;
					_tmp37_ = sound_device_get_port_name (_tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = (*source).active_port;
					_tmp40_ = (*_tmp39_).name;
					_tmp34_ = g_strcmp0 (_tmp38_, _tmp40_) == 0;
				} else {
					_tmp34_ = FALSE;
				}
				if (_tmp34_) {
					SoundDevice* _tmp41_;
					pa_source_port_info* _tmp42_;
					const gchar* _tmp43_;
					SoundDevice* _tmp44_;
					const gchar* _tmp45_;
					SoundDevice* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					SoundDevice* _tmp49_;
					SoundDevice* _tmp50_;
					const gchar* _tmp51_;
					const gchar* _tmp52_;
					const gchar* _tmp53_ = NULL;
					SoundDevice* _tmp54_;
					gboolean _tmp55_;
					gboolean _tmp56_;
					SoundDevice* _tmp57_;
					gboolean _tmp58_;
					gboolean _tmp59_;
					_tmp41_ = device;
					_tmp42_ = (*source).active_port;
					_tmp43_ = (*_tmp42_).name;
					sound_device_set_card_source_port_name (_tmp41_, _tmp43_);
					_tmp44_ = device;
					_tmp45_ = (*source).name;
					sound_device_set_source_name (_tmp44_, _tmp45_);
					_tmp46_ = device;
					_tmp47_ = sound_device_get_card_source_name (_tmp46_);
					_tmp48_ = _tmp47_;
					g_debug ("PulseAudioManager.vala:411: \t\t\tdevice.source_name: %s", _tmp48_);
					_tmp49_ = device;
					sound_device_set_source_index (_tmp49_, (gint) (*source).index);
					_tmp50_ = device;
					_tmp51_ = (*source).name;
					_tmp52_ = self->priv->default_source_name;
					sound_device_set_is_default (_tmp50_, g_strcmp0 (_tmp51_, _tmp52_) == 0);
					_tmp54_ = device;
					_tmp55_ = sound_device_get_is_default (_tmp54_);
					_tmp56_ = _tmp55_;
					if (_tmp56_) {
						_tmp53_ = "true";
					} else {
						_tmp53_ = "false";
					}
					g_debug ("PulseAudioManager.vala:414: \t\t\tis_default: %s", _tmp53_);
					_tmp57_ = device;
					_tmp58_ = sound_device_get_is_default (_tmp57_);
					_tmp59_ = _tmp58_;
					if (_tmp59_) {
						SoundDevice* _tmp60_;
						_tmp60_ = device;
						sound_pulse_audio_manager_set_default_input (self, _tmp60_);
					}
				} else {
					SoundDevice* _tmp61_;
					SoundDevice* _tmp62_;
					SoundDevice* _tmp63_;
					_tmp61_ = device;
					sound_device_set_source_name (_tmp61_, NULL);
					_tmp62_ = device;
					sound_device_set_source_index (_tmp62_, -1);
					_tmp63_ = device;
					sound_device_set_is_default (_tmp63_, FALSE);
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
}

static void
sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_sink_info* sink,
                                              gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_sink_port_info* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (sink == NULL) {
		return;
	}
	g_debug ("PulseAudioManager.vala:434: sink info update");
	_tmp0_ = (*sink).description;
	_tmp1_ = (*sink).name;
	g_debug ("PulseAudioManager.vala:435: \tsink: %s (%s)", _tmp0_, _tmp1_);
	_tmp2_ = (*sink).name;
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
		return;
	}
	g_debug ("PulseAudioManager.vala:441: \t\tcard: %u", (guint) (*sink).card);
	if (sound_pulse_audio_manager_debug_enabled) {
		pa_sink_port_info** _tmp3_;
		gint _tmp3__length1;
		_tmp3_ = (*sink).ports;
		_tmp3__length1 = (*sink).n_ports;
		{
			pa_sink_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
			port_collection = _tmp3_;
			port_collection_length1 = _tmp3__length1;
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
				pa_sink_port_info* port = NULL;
				port = port_collection[port_it];
				{
					pa_sink_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_sink_port_info* _tmp6_;
					const gchar* _tmp7_;
					_tmp4_ = port;
					_tmp5_ = (*_tmp4_).description;
					_tmp6_ = port;
					_tmp7_ = (*_tmp6_).name;
					g_debug ("PulseAudioManager.vala:445: \t\tport: %s (%s)", _tmp5_, _tmp7_);
				}
			}
		}
	}
	_tmp8_ = (*sink).active_port;
	if (_tmp8_ != NULL) {
		pa_sink_port_info* _tmp9_;
		const gchar* _tmp10_;
		pa_sink_port_info* _tmp11_;
		const gchar* _tmp12_;
		_tmp9_ = (*sink).active_port;
		_tmp10_ = (*_tmp9_).description;
		_tmp11_ = (*sink).active_port;
		_tmp12_ = (*_tmp11_).name;
		g_debug ("PulseAudioManager.vala:451: \t\tactive port: %s (%s)", _tmp10_, _tmp12_);
	}
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
		_tmp13_ = self->priv->output_devices;
		_tmp14_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = _tmp15_;
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
		_tmp18_ = _tmp17_;
		_g_object_unref0 (_tmp16_);
		_device_it = _tmp18_;
		while (TRUE) {
			GeeIterator* _tmp19_;
			SoundDevice* device = NULL;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			SoundDevice* _tmp22_;
			guint32 _tmp23_;
			guint32 _tmp24_;
			_tmp19_ = _device_it;
			if (!gee_iterator_next (_tmp19_)) {
				break;
			}
			_tmp20_ = _device_it;
			_tmp21_ = gee_iterator_get (_tmp20_);
			device = (SoundDevice*) _tmp21_;
			_tmp22_ = device;
			_tmp23_ = sound_device_get_card_index (_tmp22_);
			_tmp24_ = _tmp23_;
			if (_tmp24_ == (*sink).card) {
				SoundDevice* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SoundDevice* _tmp28_;
				SoundDevice* _tmp29_;
				const gchar* _tmp30_;
				SoundDevice* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gboolean _tmp34_ = FALSE;
				pa_sink_port_info* _tmp35_;
				_tmp25_ = device;
				_tmp26_ = sound_device_get_id (_tmp25_);
				_tmp27_ = _tmp26_;
				g_debug ("PulseAudioManager.vala:456: \t\tupdating device: %s", _tmp27_);
				_tmp28_ = device;
				sound_device_set_card_sink_index (_tmp28_, (gint) (*sink).index);
				_tmp29_ = device;
				_tmp30_ = (*sink).name;
				sound_device_set_card_sink_name (_tmp29_, _tmp30_);
				_tmp31_ = device;
				_tmp32_ = sound_device_get_card_sink_name (_tmp31_);
				_tmp33_ = _tmp32_;
				g_debug ("PulseAudioManager.vala:459: \t\t\tdevice.card_sink_name: %s", _tmp33_);
				_tmp35_ = (*sink).active_port;
				if (_tmp35_ != NULL) {
					SoundDevice* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					pa_sink_port_info* _tmp39_;
					const gchar* _tmp40_;
					_tmp36_ = device;
					_tmp37_ = sound_device_get_port_name (_tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = (*sink).active_port;
					_tmp40_ = (*_tmp39_).name;
					_tmp34_ = g_strcmp0 (_tmp38_, _tmp40_) == 0;
				} else {
					_tmp34_ = FALSE;
				}
				if (_tmp34_) {
					SoundDevice* _tmp41_;
					pa_sink_port_info* _tmp42_;
					const gchar* _tmp43_;
					SoundDevice* _tmp44_;
					const gchar* _tmp45_;
					SoundDevice* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					SoundDevice* _tmp49_;
					SoundDevice* _tmp50_;
					const gchar* _tmp51_;
					const gchar* _tmp52_;
					const gchar* _tmp53_ = NULL;
					SoundDevice* _tmp54_;
					gboolean _tmp55_;
					gboolean _tmp56_;
					SoundDevice* _tmp57_;
					gboolean _tmp58_;
					gboolean _tmp59_;
					_tmp41_ = device;
					_tmp42_ = (*sink).active_port;
					_tmp43_ = (*_tmp42_).name;
					sound_device_set_card_sink_port_name (_tmp41_, _tmp43_);
					_tmp44_ = device;
					_tmp45_ = (*sink).name;
					sound_device_set_sink_name (_tmp44_, _tmp45_);
					_tmp46_ = device;
					_tmp47_ = sound_device_get_card_sink_name (_tmp46_);
					_tmp48_ = _tmp47_;
					g_debug ("PulseAudioManager.vala:464: \t\t\tdevice.sink_name: %s", _tmp48_);
					_tmp49_ = device;
					sound_device_set_sink_index (_tmp49_, (gint) (*sink).index);
					_tmp50_ = device;
					_tmp51_ = (*sink).name;
					_tmp52_ = self->priv->default_sink_name;
					sound_device_set_is_default (_tmp50_, g_strcmp0 (_tmp51_, _tmp52_) == 0);
					_tmp54_ = device;
					_tmp55_ = sound_device_get_is_default (_tmp54_);
					_tmp56_ = _tmp55_;
					if (_tmp56_) {
						_tmp53_ = "true";
					} else {
						_tmp53_ = "false";
					}
					g_debug ("PulseAudioManager.vala:467: \t\t\tis_default: %s", _tmp53_);
					_tmp57_ = device;
					_tmp58_ = sound_device_get_is_default (_tmp57_);
					_tmp59_ = _tmp58_;
					if (_tmp59_) {
						SoundDevice* _tmp60_;
						_tmp60_ = device;
						sound_pulse_audio_manager_set_default_output (self, _tmp60_);
					}
				} else {
					SoundDevice* _tmp61_;
					SoundDevice* _tmp62_;
					SoundDevice* _tmp63_;
					_tmp61_ = device;
					sound_device_set_sink_name (_tmp61_, NULL);
					_tmp62_ = device;
					sound_device_set_sink_index (_tmp62_, -1);
					_tmp63_ = device;
					sound_device_set_is_default (_tmp63_, FALSE);
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
}

static void
_vala_array_add1 (pa_card_port_info** * array,
                  gint* length,
                  gint* size,
                  pa_card_port_info* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (pa_card_port_info*, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_card_info* card,
                                              gint eol)
{
	pa_proplist* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_card_profile_info2* _tmp3_;
	const gchar* _tmp4_;
	pa_proplist* _tmp5_;
	const gchar* _tmp6_;
	pa_proplist* _tmp7_;
	const gchar* _tmp8_;
	gchar* card_active_profile_name = NULL;
	pa_card_profile_info2* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	pa_card_port_info** relevant_ports = NULL;
	pa_card_port_info** _tmp12_;
	gint relevant_ports_length1;
	gint _relevant_ports_size_;
	guint32 highest_output_priority = 0U;
	guint32 highest_input_priority = 0U;
	pa_card_port_info** _tmp13_;
	gint _tmp13__length1;
	GVariant* preferred_devices = NULL;
	GSettings* _tmp25_;
	GVariant* _tmp26_;
	GeeHashMap* preferred_device_map = NULL;
	GeeHashMap* _tmp27_;
	gint32 preferred_expiry = 0;
	pa_card_port_info** _tmp45_;
	gint _tmp45__length1;
	GeeHashMap* _tmp147_;
	pa_card_port_info** _tmp148_;
	gint _tmp148__length1;
	pa_card_info _tmp149_;
	GeeHashMap* _tmp150_;
	pa_card_port_info** _tmp151_;
	gint _tmp151__length1;
	pa_card_info _tmp152_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (card == NULL) {
		return;
	}
	g_debug ("PulseAudioManager.vala:487: card info update");
	_tmp0_ = (*card).proplist;
	_tmp1_ = pa_proplist_gets (_tmp0_, PA_PROP_DEVICE_DESCRIPTION);
	_tmp2_ = (*card).name;
	g_debug ("PulseAudioManager.vala:488: \tcard: %u %s (%s)", (guint) (*card).index, _tmp1_, _tmp2_);
	_tmp3_ = (*card).active_profile2;
	_tmp4_ = (*_tmp3_).name;
	g_debug ("PulseAudioManager.vala:490: \t\tactive profile: %s", _tmp4_);
	_tmp5_ = (*card).proplist;
	_tmp6_ = pa_proplist_gets (_tmp5_, PA_PROP_DEVICE_FORM_FACTOR);
	g_debug ("PulseAudioManager.vala:492: \t\tcard form factor: %s", _tmp6_);
	_tmp7_ = (*card).proplist;
	_tmp8_ = pa_proplist_gets (_tmp7_, PA_PROP_MEDIA_ICON_NAME);
	g_debug ("PulseAudioManager.vala:493: \t\tcard icon name: %s", _tmp8_);
	_tmp9_ = (*card).active_profile2;
	_tmp10_ = (*_tmp9_).name;
	_tmp11_ = g_strdup (_tmp10_);
	card_active_profile_name = _tmp11_;
	_tmp12_ = g_new0 (pa_card_port_info*, 0);
	relevant_ports = _tmp12_;
	relevant_ports_length1 = 0;
	_relevant_ports_size_ = relevant_ports_length1;
	highest_output_priority = (guint32) 0;
	highest_input_priority = (guint32) 0;
	_tmp13_ = (*card).ports;
	_tmp13__length1 = (*card).n_ports;
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
		port_collection = _tmp13_;
		port_collection_length1 = _tmp13__length1;
		for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
			pa_card_port_info* port = NULL;
			port = port_collection[port_it];
			{
				pa_card_port_info* _tmp14_;
				pa_port_available_t _tmp15_;
				gboolean is_input = FALSE;
				pa_card_port_info* _tmp16_;
				pa_direction_t _tmp17_;
				gboolean _tmp18_ = FALSE;
				gboolean _tmp21_ = FALSE;
				pa_card_port_info* _tmp24_;
				_tmp14_ = port;
				_tmp15_ = (*_tmp14_).available;
				if (_tmp15_ == PA_PORT_AVAILABLE_NO) {
					continue;
				}
				_tmp16_ = port;
				_tmp17_ = (*_tmp16_).direction;
				is_input = (_tmp17_ & PA_DIRECTION_INPUT) == PA_DIRECTION_INPUT;
				if (is_input) {
					pa_card_port_info* _tmp19_;
					_tmp19_ = port;
					_tmp18_ = (*_tmp19_).priority > highest_input_priority;
				} else {
					_tmp18_ = FALSE;
				}
				if (_tmp18_) {
					pa_card_port_info* _tmp20_;
					_tmp20_ = port;
					highest_input_priority = (*_tmp20_).priority;
				}
				if (!is_input) {
					pa_card_port_info* _tmp22_;
					_tmp22_ = port;
					_tmp21_ = (*_tmp22_).priority > highest_output_priority;
				} else {
					_tmp21_ = FALSE;
				}
				if (_tmp21_) {
					pa_card_port_info* _tmp23_;
					_tmp23_ = port;
					highest_output_priority = (*_tmp23_).priority;
				}
				_tmp24_ = port;
				_vala_array_add1 (&relevant_ports, &relevant_ports_length1, &_relevant_ports_size_, _tmp24_);
			}
		}
	}
	_tmp25_ = sound_indicator_settings;
	_tmp26_ = g_settings_get_value (_tmp25_, "preferred-devices");
	preferred_devices = _tmp26_;
	_tmp27_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	preferred_device_map = _tmp27_;
	preferred_expiry = ((gint32) (g_get_real_time () / 1000000)) - (86400 * 7);
	{
		GVariantIter* _dev_it = NULL;
		GVariant* _tmp28_;
		GVariantIter* _tmp29_;
		GVariant* dev = NULL;
		_tmp28_ = preferred_devices;
		_tmp29_ = g_variant_iter_new (_tmp28_);
		_dev_it = _tmp29_;
		while (TRUE) {
			GVariantIter* _tmp30_;
			GVariant* _tmp31_;
			GVariant* _tmp32_;
			gchar* name = NULL;
			GVariant* _tmp33_;
			GVariant* _tmp34_;
			GVariant* _tmp35_;
			const gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gint32 last_used = 0;
			GVariant* _tmp39_;
			GVariant* _tmp40_;
			GVariant* _tmp41_;
			gint32 _tmp42_;
			GeeHashMap* _tmp43_;
			const gchar* _tmp44_;
			_tmp30_ = _dev_it;
			_tmp31_ = g_variant_iter_next_value (_tmp30_);
			_g_variant_unref0 (dev);
			dev = _tmp31_;
			_tmp32_ = dev;
			if (!(_tmp32_ != NULL)) {
				break;
			}
			_tmp33_ = dev;
			_tmp34_ = g_variant_get_child_value (_tmp33_, (gsize) 0);
			_tmp35_ = _tmp34_;
			_tmp36_ = g_variant_get_string (_tmp35_, NULL);
			_tmp37_ = g_strdup (_tmp36_);
			_tmp38_ = _tmp37_;
			_g_variant_unref0 (_tmp35_);
			name = _tmp38_;
			_tmp39_ = dev;
			_tmp40_ = g_variant_get_child_value (_tmp39_, (gsize) 1);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_variant_get_int32 (_tmp41_);
			_g_variant_unref0 (_tmp41_);
			last_used = _tmp42_;
			_tmp43_ = preferred_device_map;
			_tmp44_ = name;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp43_, _tmp44_, (gpointer) ((gintptr) last_used));
			_g_free0 (name);
		}
		_g_variant_unref0 (dev);
		_g_variant_iter_free0 (_dev_it);
	}
	_tmp45_ = relevant_ports;
	_tmp45__length1 = relevant_ports_length1;
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
		port_collection = _tmp45_;
		port_collection_length1 = _tmp45__length1;
		for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
			pa_card_port_info* port = NULL;
			port = port_collection[port_it];
			{
				gboolean is_input = FALSE;
				pa_card_port_info* _tmp46_;
				pa_direction_t _tmp47_;
				const gchar* _tmp48_ = NULL;
				pa_card_port_info* _tmp49_;
				const gchar* _tmp50_;
				pa_card_port_info* _tmp51_;
				const gchar* _tmp52_;
				GeeHashMap* _tmp53_ = NULL;
				GeeHashMap* devices = NULL;
				GeeHashMap* _tmp56_;
				SoundDevice* device = NULL;
				gchar* id = NULL;
				pa_card_port_info* _tmp57_;
				pa_card_info _tmp58_;
				gchar* _tmp59_;
				gboolean is_new = FALSE;
				GeeHashMap* _tmp60_;
				const gchar* _tmp61_;
				SoundDevice* _tmp71_;
				const gchar* _tmp72_;
				SoundDevice* _tmp73_;
				guint32 _tmp74_ = 0U;
				SoundDevice* _tmp75_;
				pa_card_port_info* _tmp76_;
				gboolean _tmp77_ = FALSE;
				GeeHashMap* _tmp78_;
				GeeSet* _tmp79_;
				GeeSet* _tmp80_;
				GeeSet* _tmp81_;
				const gchar* _tmp82_;
				gboolean _tmp83_;
				gchar* card_description = NULL;
				pa_proplist* _tmp88_;
				const gchar* _tmp89_;
				gchar* _tmp90_;
				SoundDevice* _tmp91_;
				const gchar* _tmp92_;
				const gchar* _tmp93_;
				pa_card_port_info* _tmp94_;
				const gchar* _tmp95_;
				const gchar* _tmp96_;
				gchar* _tmp97_;
				gchar* _tmp98_;
				SoundDevice* _tmp99_;
				pa_card_port_info* _tmp100_;
				pa_proplist* _tmp101_;
				const gchar* _tmp102_;
				SoundDevice* _tmp103_;
				const gchar* _tmp104_;
				const gchar* _tmp105_;
				SoundDevice* _tmp109_;
				const gchar* _tmp110_;
				const gchar* _tmp111_;
				SoundDevice* _tmp112_;
				pa_card_port_info* _tmp113_;
				pa_proplist* _tmp114_;
				const gchar* _tmp115_;
				SoundDevice* _tmp116_;
				const gchar* _tmp117_;
				const gchar* _tmp118_;
				gboolean _tmp122_ = FALSE;
				SoundDevice* _tmp127_;
				pa_card_port_info* _tmp128_;
				GeeArrayList* _tmp129_;
				GeeArrayList* _tmp130_;
				_tmp46_ = port;
				_tmp47_ = (*_tmp46_).direction;
				is_input = (_tmp47_ & PA_DIRECTION_INPUT) == PA_DIRECTION_INPUT;
				if (is_input) {
					_tmp48_ = "input";
				} else {
					_tmp48_ = "output";
				}
				_tmp49_ = port;
				_tmp50_ = (*_tmp49_).description;
				_tmp51_ = port;
				_tmp52_ = (*_tmp51_).name;
				g_debug ("PulseAudioManager.vala:528: \t\t%s port: %s (%s)", _tmp48_, _tmp50_, _tmp52_);
				if (is_input) {
					GeeHashMap* _tmp54_;
					_tmp54_ = self->priv->input_devices;
					_tmp53_ = _tmp54_;
				} else {
					GeeHashMap* _tmp55_;
					_tmp55_ = self->priv->output_devices;
					_tmp53_ = _tmp55_;
				}
				_tmp56_ = _g_object_ref0 (_tmp53_);
				devices = _tmp56_;
				device = NULL;
				_tmp57_ = port;
				_tmp58_ = *card;
				_tmp59_ = sound_pulse_audio_manager_get_device_id (&_tmp58_, _tmp57_);
				id = _tmp59_;
				_tmp60_ = devices;
				_tmp61_ = id;
				is_new = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp60_, _tmp61_);
				if (is_new) {
					const gchar* _tmp62_;
					const gchar* _tmp63_;
					pa_card_port_info* _tmp64_;
					const gchar* _tmp65_;
					SoundDevice* _tmp66_;
					_tmp62_ = id;
					g_debug ("PulseAudioManager.vala:534: \t\t\tnew device: %s", _tmp62_);
					_tmp63_ = id;
					_tmp64_ = port;
					_tmp65_ = (*_tmp64_).name;
					_tmp66_ = sound_device_new (_tmp63_, (*card).index, _tmp65_);
					_g_object_unref0 (device);
					device = _tmp66_;
				} else {
					const gchar* _tmp67_;
					GeeHashMap* _tmp68_;
					const gchar* _tmp69_;
					gpointer _tmp70_;
					_tmp67_ = id;
					g_debug ("PulseAudioManager.vala:537: \t\t\tupdating device: %s", _tmp67_);
					_tmp68_ = devices;
					_tmp69_ = id;
					_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp68_, _tmp69_);
					_g_object_unref0 (device);
					device = (SoundDevice*) _tmp70_;
				}
				_tmp71_ = device;
				_tmp72_ = card_active_profile_name;
				sound_device_set_card_active_profile_name (_tmp71_, _tmp72_);
				_tmp73_ = device;
				sound_device_set_input (_tmp73_, is_input);
				if (is_input) {
					_tmp74_ = highest_input_priority;
				} else {
					_tmp74_ = highest_output_priority;
				}
				_tmp75_ = device;
				_tmp76_ = port;
				sound_device_set_is_priority (_tmp75_, (*_tmp76_).priority == _tmp74_);
				_tmp78_ = preferred_device_map;
				_tmp79_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp78_);
				_tmp80_ = _tmp79_;
				_tmp81_ = _tmp80_;
				_tmp82_ = id;
				_tmp83_ = gee_collection_contains ((GeeCollection*) _tmp81_, _tmp82_);
				_g_object_unref0 (_tmp81_);
				if (_tmp83_) {
					GeeHashMap* _tmp84_;
					const gchar* _tmp85_;
					gpointer _tmp86_;
					_tmp84_ = preferred_device_map;
					_tmp85_ = id;
					_tmp86_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp84_, _tmp85_);
					_tmp77_ = ((gint32) ((gintptr) _tmp86_)) > preferred_expiry;
				} else {
					_tmp77_ = FALSE;
				}
				if (_tmp77_) {
					SoundDevice* _tmp87_;
					_tmp87_ = device;
					sound_device_set_is_priority (_tmp87_, TRUE);
				}
				_tmp88_ = (*card).proplist;
				_tmp89_ = pa_proplist_gets (_tmp88_, PA_PROP_DEVICE_DESCRIPTION);
				_tmp90_ = g_strdup (_tmp89_);
				card_description = _tmp90_;
				_tmp91_ = device;
				_tmp92_ = card_description;
				_tmp93_ = string_to_string (_tmp92_);
				_tmp94_ = port;
				_tmp95_ = (*_tmp94_).description;
				_tmp96_ = string_to_string (_tmp95_);
				_tmp97_ = g_strconcat (_tmp93_, ": ", _tmp96_, NULL);
				_tmp98_ = _tmp97_;
				sound_device_set_display_name (_tmp91_, _tmp98_);
				_g_free0 (_tmp98_);
				_tmp99_ = device;
				_tmp100_ = port;
				_tmp101_ = (*_tmp100_).proplist;
				_tmp102_ = pa_proplist_gets (_tmp101_, PA_PROP_DEVICE_FORM_FACTOR);
				sound_device_set_form_factor (_tmp99_, _tmp102_);
				_tmp103_ = device;
				_tmp104_ = sound_device_get_form_factor (_tmp103_);
				_tmp105_ = _tmp104_;
				if (_tmp105_ == NULL) {
					SoundDevice* _tmp106_;
					pa_proplist* _tmp107_;
					const gchar* _tmp108_;
					_tmp106_ = device;
					_tmp107_ = (*card).proplist;
					_tmp108_ = pa_proplist_gets (_tmp107_, PA_PROP_DEVICE_FORM_FACTOR);
					sound_device_set_form_factor (_tmp106_, _tmp108_);
				}
				_tmp109_ = device;
				_tmp110_ = sound_device_get_form_factor (_tmp109_);
				_tmp111_ = _tmp110_;
				g_debug ("PulseAudioManager.vala:554: \t\t\tform factor: %s", _tmp111_);
				_tmp112_ = device;
				_tmp113_ = port;
				_tmp114_ = (*_tmp113_).proplist;
				_tmp115_ = pa_proplist_gets (_tmp114_, PA_PROP_DEVICE_ICON_NAME);
				sound_device_set_icon_name (_tmp112_, _tmp115_);
				_tmp116_ = device;
				_tmp117_ = sound_device_get_icon_name (_tmp116_);
				_tmp118_ = _tmp117_;
				if (_tmp118_ == NULL) {
					SoundDevice* _tmp119_;
					pa_proplist* _tmp120_;
					const gchar* _tmp121_;
					_tmp119_ = device;
					_tmp120_ = (*card).proplist;
					_tmp121_ = pa_proplist_gets (_tmp120_, PA_PROP_DEVICE_ICON_NAME);
					sound_device_set_icon_name (_tmp119_, _tmp121_);
				}
				if (is_input) {
					SoundDevice* _tmp123_;
					const gchar* _tmp124_;
					const gchar* _tmp125_;
					_tmp123_ = device;
					_tmp124_ = sound_device_get_icon_name (_tmp123_);
					_tmp125_ = _tmp124_;
					_tmp122_ = g_str_has_prefix (_tmp125_, "audio-card");
				} else {
					_tmp122_ = FALSE;
				}
				if (_tmp122_) {
					SoundDevice* _tmp126_;
					_tmp126_ = device;
					sound_device_set_icon_name (_tmp126_, "audio-input-microphone");
				}
				_tmp127_ = device;
				_tmp128_ = port;
				_tmp129_ = sound_pulse_audio_manager_get_relevant_card_port_profiles (self, _tmp128_);
				_tmp130_ = _tmp129_;
				sound_device_set_profiles (_tmp127_, _tmp130_);
				_g_object_unref0 (_tmp130_);
				if (sound_pulse_audio_manager_debug_enabled) {
					{
						GeeArrayList* _profile_list = NULL;
						SoundDevice* _tmp131_;
						GeeArrayList* _tmp132_;
						GeeArrayList* _tmp133_;
						GeeArrayList* _tmp134_;
						gint _profile_size = 0;
						GeeArrayList* _tmp135_;
						gint _tmp136_;
						gint _tmp137_;
						gint _profile_index = 0;
						_tmp131_ = device;
						_tmp132_ = sound_device_get_profiles (_tmp131_);
						_tmp133_ = _tmp132_;
						_tmp134_ = _g_object_ref0 (_tmp133_);
						_profile_list = _tmp134_;
						_tmp135_ = _profile_list;
						_tmp136_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp135_);
						_tmp137_ = _tmp136_;
						_profile_size = _tmp137_;
						_profile_index = -1;
						while (TRUE) {
							gint _tmp138_;
							gint _tmp139_;
							gchar* profile = NULL;
							GeeArrayList* _tmp140_;
							gpointer _tmp141_;
							const gchar* _tmp142_;
							_profile_index = _profile_index + 1;
							_tmp138_ = _profile_index;
							_tmp139_ = _profile_size;
							if (!(_tmp138_ < _tmp139_)) {
								break;
							}
							_tmp140_ = _profile_list;
							_tmp141_ = gee_abstract_list_get ((GeeAbstractList*) _tmp140_, _profile_index);
							profile = (gchar*) _tmp141_;
							_tmp142_ = profile;
							g_debug ("PulseAudioManager.vala:569: \t\t\tprofile: %s", _tmp142_);
							_g_free0 (profile);
						}
						_g_object_unref0 (_profile_list);
					}
				}
				if (is_new) {
					GeeHashMap* _tmp143_;
					const gchar* _tmp144_;
					SoundDevice* _tmp145_;
					SoundDevice* _tmp146_;
					_tmp143_ = devices;
					_tmp144_ = id;
					_tmp145_ = device;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp143_, _tmp144_, _tmp145_);
					_tmp146_ = device;
					g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp146_);
				}
				_g_free0 (card_description);
				_g_free0 (id);
				_g_object_unref0 (device);
				_g_object_unref0 (devices);
			}
		}
	}
	_tmp147_ = self->priv->output_devices;
	_tmp148_ = relevant_ports;
	_tmp148__length1 = relevant_ports_length1;
	_tmp149_ = *card;
	sound_pulse_audio_manager_cleanup_devices (self, _tmp147_, &_tmp149_, _tmp148_, (gint) _tmp148__length1);
	_tmp150_ = self->priv->input_devices;
	_tmp151_ = relevant_ports;
	_tmp151__length1 = relevant_ports_length1;
	_tmp152_ = *card;
	sound_pulse_audio_manager_cleanup_devices (self, _tmp150_, &_tmp152_, _tmp151_, (gint) _tmp151__length1);
	_g_object_unref0 (preferred_device_map);
	_g_variant_unref0 (preferred_devices);
	relevant_ports = (g_free (relevant_ports), NULL);
	_g_free0 (card_active_profile_name);
}

static void
sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                           GeeHashMap* devices,
                                           pa_card_info* card,
                                           pa_card_port_info** relevant_ports,
                                           gint relevant_ports_length1)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (devices != NULL);
	g_return_if_fail (card != NULL);
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
	iter = _tmp0_;
	while (TRUE) {
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		pa_card_info _tmp7_;
		gboolean found = FALSE;
		_tmp1_ = iter;
		if (!gee_map_iterator_next (_tmp1_)) {
			break;
		}
		_tmp2_ = iter;
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
		device = (SoundDevice*) _tmp3_;
		_tmp4_ = device;
		_tmp5_ = sound_device_get_card_index (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = *card;
		if (_tmp6_ != _tmp7_.index) {
			_g_object_unref0 (device);
			continue;
		}
		found = FALSE;
		{
			pa_card_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
			port_collection = relevant_ports;
			port_collection_length1 = relevant_ports_length1;
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
				pa_card_port_info* port = NULL;
				port = port_collection[port_it];
				{
					SoundDevice* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					pa_card_info _tmp11_;
					pa_card_port_info* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gboolean _tmp15_;
					_tmp8_ = device;
					_tmp9_ = sound_device_get_id (_tmp8_);
					_tmp10_ = _tmp9_;
					_tmp11_ = *card;
					_tmp12_ = port;
					_tmp13_ = sound_pulse_audio_manager_get_device_id (&_tmp11_, _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
					_g_free0 (_tmp14_);
					if (_tmp15_) {
						found = TRUE;
						break;
					}
				}
			}
		}
		if (!found) {
			SoundDevice* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			SoundDevice* _tmp19_;
			GeeMapIterator* _tmp20_;
			_tmp16_ = device;
			_tmp17_ = sound_device_get_id (_tmp16_);
			_tmp18_ = _tmp17_;
			g_debug ("PulseAudioManager.vala:604: \t\tremoving device: %s", _tmp18_);
			_tmp19_ = device;
			g_signal_emit_by_name (_tmp19_, "removed");
			_tmp20_ = iter;
			gee_map_iterator_unset (_tmp20_);
		}
		_g_object_unref0 (device);
	}
	_g_object_unref0 (iter);
}

static gchar*
sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                         pa_card_port_info* port)
{
	pa_card_info _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (card != NULL, NULL);
	_tmp0_ = *card;
	_tmp1_ = _tmp0_.name;
	_tmp2_ = string_to_string (_tmp1_);
	_tmp3_ = (*port).name;
	_tmp4_ = string_to_string (_tmp3_);
	_tmp5_ = g_strconcat (_tmp2_, ":", _tmp4_, NULL);
	result = _tmp5_;
	return result;
}

static pa_card_profile_info2**
_vala_array_dup1 (pa_card_profile_info2** self,
                  gint length)
{
	if (length > 0) {
		return g_memdup (self, length * sizeof (pa_card_profile_info2*));
	}
	return NULL;
}

static gint
__lambda44_ (SoundPulseAudioManager* self,
             pa_card_profile_info2* a,
             pa_card_profile_info2* b)
{
	gint result = 0;
	if ((*a).priority > (*b).priority) {
		result = -1;
		return result;
	}
	if ((*a).priority < (*b).priority) {
		result = 1;
		return result;
	}
	result = 0;
	return result;
}

static gint
___lambda44__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda44_ ((SoundPulseAudioManager*) self, a, b);
	return result;
}

static GeeArrayList*
sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                           pa_card_port_info* port)
{
	GeeArrayList* profiles_list = NULL;
	pa_card_profile_info2** _tmp0_;
	gint _tmp0__length1;
	pa_card_profile_info2** _tmp1_;
	gint _tmp1__length1;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* profiles = NULL;
	GeeArrayList* _tmp4_;
	GeeArrayList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (*port).profiles2;
	_tmp0__length1 = (*port).n_profiles;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	_tmp2_ = gee_array_list_new_wrap (G_TYPE_POINTER, NULL, NULL, _tmp1_, _tmp1__length1, NULL, NULL, NULL);
	profiles_list = _tmp2_;
	_tmp3_ = profiles_list;
	gee_list_sort ((GeeList*) _tmp3_, ___lambda44__gcompare_data_func, g_object_ref (self), g_object_unref);
	_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	profiles = _tmp4_;
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		gint _item_size = 0;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _item_index = 0;
		_tmp5_ = profiles_list;
		_tmp6_ = _g_object_ref0 (_tmp5_);
		_item_list = _tmp6_;
		_tmp7_ = _item_list;
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
		_tmp9_ = _tmp8_;
		_item_size = _tmp9_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp10_;
			gint _tmp11_;
			pa_card_profile_info2* item = NULL;
			GeeArrayList* _tmp12_;
			gpointer _tmp13_;
			GeeArrayList* _tmp14_;
			pa_card_profile_info2* _tmp15_;
			const gchar* _tmp16_;
			_item_index = _item_index + 1;
			_tmp10_ = _item_index;
			_tmp11_ = _item_size;
			if (!(_tmp10_ < _tmp11_)) {
				break;
			}
			_tmp12_ = _item_list;
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _item_index);
			item = _tmp13_;
			_tmp14_ = profiles;
			_tmp15_ = item;
			_tmp16_ = (*_tmp15_).name;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp16_);
		}
		_g_object_unref0 (_item_list);
	}
	result = profiles;
	_g_object_unref0 (profiles_list);
	return result;
}

static void
sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                  GeeHashMap* devices,
                                                  guint32 card_index)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (devices != NULL);
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
	iter = _tmp0_;
	while (TRUE) {
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		_tmp1_ = iter;
		if (!gee_map_iterator_next (_tmp1_)) {
			break;
		}
		_tmp2_ = iter;
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
		device = (SoundDevice*) _tmp3_;
		_tmp4_ = device;
		_tmp5_ = sound_device_get_card_index (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_ == card_index) {
			SoundDevice* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			SoundDevice* _tmp10_;
			GeeMapIterator* _tmp11_;
			_tmp7_ = device;
			_tmp8_ = sound_device_get_id (_tmp7_);
			_tmp9_ = _tmp8_;
			g_debug ("PulseAudioManager.vala:645: removing device: %s", _tmp9_);
			_tmp10_ = device;
			g_signal_emit_by_name (_tmp10_, "removed");
			_tmp11_ = iter;
			gee_map_iterator_unset (_tmp11_);
		}
		_g_object_unref0 (device);
	}
	_g_object_unref0 (iter);
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                         pa_ext_stream_restore_info* info,
                                                                                                         gint eol,
                                                                                                         gpointer self)
{
	sound_pulse_audio_manager_ext_stream_restore_read_sink_callback ((SoundPulseAudioManager*) self, c, info, eol);
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                           pa_ext_stream_restore_info* info,
                                                                                                           gint eol,
                                                                                                           gpointer self)
{
	sound_pulse_audio_manager_ext_stream_restore_read_source_callback ((SoundPulseAudioManager*) self, c, info, eol);
}

static void
sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                pa_context* context,
                                                pa_server_info* server)
{
	const gchar* _tmp0_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp12_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	pa_operation* _tmp24_;
	pa_operation* _tmp25_;
	pa_operation* _tmp26_;
	pa_operation* _tmp27_;
	pa_operation* _tmp28_;
	pa_operation* _tmp29_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_debug ("PulseAudioManager.vala:653: server info update");
	if (server == NULL) {
		return;
	}
	_tmp0_ = self->priv->default_sink_name;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp1_ = (*server).default_sink_name;
		_tmp2_ = g_strdup (_tmp1_);
		_g_free0 (self->priv->default_sink_name);
		self->priv->default_sink_name = _tmp2_;
		_tmp3_ = self->priv->default_sink_name;
		g_debug ("PulseAudioManager.vala:660: \tdefault_sink_name: %s", _tmp3_);
	}
	_tmp4_ = self->priv->default_sink_name;
	_tmp5_ = (*server).default_sink_name;
	if (g_strcmp0 (_tmp4_, _tmp5_) != 0) {
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		pa_operation* _tmp10_;
		pa_operation* _tmp11_;
		_tmp6_ = self->priv->default_sink_name;
		_tmp7_ = (*server).default_sink_name;
		g_debug ("PulseAudioManager.vala:664: \tdefault_sink_name: %s > %s", _tmp6_, _tmp7_);
		_tmp8_ = (*server).default_sink_name;
		_tmp9_ = g_strdup (_tmp8_);
		_g_free0 (self->priv->default_sink_name);
		self->priv->default_sink_name = _tmp9_;
		_tmp10_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb, self);
		_tmp11_ = _tmp10_;
		_pa_operation_unref0 (_tmp11_);
	}
	_tmp12_ = self->priv->default_source_name;
	if (_tmp12_ == NULL) {
		const gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		_tmp13_ = (*server).default_source_name;
		_tmp14_ = g_strdup (_tmp13_);
		_g_free0 (self->priv->default_source_name);
		self->priv->default_source_name = _tmp14_;
		_tmp15_ = self->priv->default_source_name;
		g_debug ("PulseAudioManager.vala:671: \tdefault_source_name: %s", _tmp15_);
	}
	_tmp16_ = self->priv->default_source_name;
	_tmp17_ = (*server).default_source_name;
	if (g_strcmp0 (_tmp16_, _tmp17_) != 0) {
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		pa_operation* _tmp22_;
		pa_operation* _tmp23_;
		_tmp18_ = self->priv->default_source_name;
		_tmp19_ = (*server).default_source_name;
		g_debug ("PulseAudioManager.vala:675: \tdefault_source_name: %s > %s", _tmp18_, _tmp19_);
		_tmp20_ = (*server).default_source_name;
		_tmp21_ = g_strdup (_tmp20_);
		_g_free0 (self->priv->default_source_name);
		self->priv->default_source_name = _tmp21_;
		_tmp22_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb, self);
		_tmp23_ = _tmp22_;
		_pa_operation_unref0 (_tmp23_);
	}
	_tmp24_ = pa_context_get_card_info_list (context, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
	_tmp25_ = _tmp24_;
	_pa_operation_unref0 (_tmp25_);
	_tmp26_ = pa_context_get_source_info_list (context, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
	_tmp27_ = _tmp26_;
	_pa_operation_unref0 (_tmp27_);
	_tmp28_ = pa_context_get_sink_info_list (context, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
	_tmp29_ = _tmp28_;
	_pa_operation_unref0 (_tmp29_);
}

static void
__lambda43_ (SoundPulseAudioManager* self,
             pa_context* c,
             gint success)
{
	g_return_if_fail (c != NULL);
	if (success != 1) {
		g_warning ("PulseAudioManager.vala:707: Updating source failed");
	}
}

static void
___lambda43__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda43_ ((SoundPulseAudioManager*) self, c, success);
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                 pa_context* c,
                                                                 pa_ext_stream_restore_info* info,
                                                                 gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (eol != 0) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp1_;
		_tmp1_ = (*info).name;
		_tmp0_ = !g_str_has_prefix (_tmp1_, "sink-input-by");
	}
	if (_tmp0_) {
		return;
	}
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
	_tmp2_ = (*info).name;
	new_info.name = _tmp2_;
	_tmp3_ = (*info).channel_map;
	new_info.channel_map = _tmp3_;
	_tmp4_ = (*info).volume;
	new_info.volume = _tmp4_;
	new_info.mute = (*info).mute;
	_tmp5_ = self->priv->default_sink_name;
	new_info.device = _tmp5_;
	_tmp6_ = new_info;
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
	_tmp7_[0] = _tmp6_;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = 1;
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, ___lambda43__pa_context_success_cb_t, self);
	_tmp10_ = _tmp9_;
	_pa_operation_unref0 (_tmp10_);
	_tmp8_ = (g_free (_tmp8_), NULL);
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                   pa_context* c,
                                                                   pa_ext_stream_restore_info* info,
                                                                   gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (eol != 0) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp1_;
		_tmp1_ = (*info).name;
		_tmp0_ = !g_str_has_prefix (_tmp1_, "source-output-by");
	}
	if (_tmp0_) {
		return;
	}
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
	_tmp2_ = (*info).name;
	new_info.name = _tmp2_;
	_tmp3_ = (*info).channel_map;
	new_info.channel_map = _tmp3_;
	_tmp4_ = (*info).volume;
	new_info.volume = _tmp4_;
	new_info.mute = (*info).mute;
	_tmp5_ = self->priv->default_source_name;
	new_info.device = _tmp5_;
	_tmp6_ = new_info;
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
	_tmp7_[0] = _tmp6_;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = 1;
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, NULL, NULL);
	_tmp10_ = _tmp9_;
	_pa_operation_unref0 (_tmp10_);
	_tmp8_ = (g_free (_tmp8_), NULL);
}

SoundDevice*
sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_output;
	result = _tmp0_;
	return result;
}

static void
sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                              SoundDevice* value)
{
	SoundDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_pulse_audio_manager_get_default_output (self);
	if (old_value != value) {
		SoundDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_default_output);
		self->priv->_default_output = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY]);
	}
}

SoundDevice*
sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_input;
	result = _tmp0_;
	return result;
}

static void
sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                             SoundDevice* value)
{
	SoundDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_pulse_audio_manager_get_default_input (self);
	if (old_value != value) {
		SoundDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_default_input);
		self->priv->_default_input = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY]);
	}
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gint stack_length,
                             const gchar* needle)
{
	gint i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static GObject *
sound_pulse_audio_manager_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundPulseAudioManager * self;
	pa_glib_mainloop* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	gchar* messages_debug_raw = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	parent_class = G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	_tmp0_ = pa_glib_mainloop_new (NULL);
	_pa_glib_mainloop_free0 (self->priv->loop);
	self->priv->loop = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->input_devices);
	self->priv->input_devices = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->output_devices);
	self->priv->output_devices = _tmp2_;
	_tmp3_ = g_getenv ("G_MESSAGES_DEBUG");
	_tmp4_ = g_strdup (_tmp3_);
	messages_debug_raw = _tmp4_;
	_tmp5_ = messages_debug_raw;
	if (_tmp5_ != NULL) {
		gchar** messages_debug = NULL;
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint messages_debug_length1;
		gint _messages_debug_size_;
		gboolean _tmp9_ = FALSE;
		gchar** _tmp10_;
		gint _tmp10__length1;
		_tmp6_ = messages_debug_raw;
		_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, " ", 0);
		messages_debug = _tmp8_;
		messages_debug_length1 = _vala_array_length (_tmp7_);
		_messages_debug_size_ = messages_debug_length1;
		_tmp10_ = messages_debug;
		_tmp10__length1 = messages_debug_length1;
		if (_vala_string_array_contains (_tmp10_, _tmp10__length1, "all")) {
			_tmp9_ = TRUE;
		} else {
			gchar** _tmp11_;
			gint _tmp11__length1;
			_tmp11_ = messages_debug;
			_tmp11__length1 = messages_debug_length1;
			_tmp9_ = _vala_string_array_contains (_tmp11_, _tmp11__length1, "debug");
		}
		sound_pulse_audio_manager_debug_enabled = _tmp9_;
		messages_debug = (_vala_array_free (messages_debug, messages_debug_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_free0 (messages_debug_raw);
	return obj;
}

static void
sound_pulse_audio_manager_class_init (SoundPulseAudioManagerClass * klass,
                                      gpointer klass_data)
{
	sound_pulse_audio_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SoundPulseAudioManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_pulse_audio_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_pulse_audio_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = sound_pulse_audio_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = sound_pulse_audio_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY] = g_param_spec_object ("default-output", "default-output", "default-output", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY] = g_param_spec_object ("default-input", "default-input", "default-input", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL] = g_signal_new ("new-device", SOUND_TYPE_PULSE_AUDIO_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SOUND_TYPE_DEVICE);
}

static void
sound_pulse_audio_manager_instance_init (SoundPulseAudioManager * self,
                                         gpointer klass)
{
	self->priv = sound_pulse_audio_manager_get_instance_private (self);
	self->priv->is_ready = FALSE;
	self->priv->reconnect_timer_id = 0U;
}

static void
sound_pulse_audio_manager_finalize (GObject * obj)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	_pa_context_unref0 (self->priv->context);
	_pa_glib_mainloop_free0 (self->priv->loop);
	_g_object_unref0 (self->priv->input_devices);
	_g_object_unref0 (self->priv->output_devices);
	_g_object_unref0 (self->priv->_default_output);
	_g_object_unref0 (self->priv->_default_input);
	_g_free0 (self->priv->default_source_name);
	_g_free0 (self->priv->default_sink_name);
	G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class)->finalize (obj);
}

static GType
sound_pulse_audio_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundPulseAudioManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_pulse_audio_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPulseAudioManager), 0, (GInstanceInitFunc) sound_pulse_audio_manager_instance_init, NULL };
	GType sound_pulse_audio_manager_type_id;
	sound_pulse_audio_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundPulseAudioManager", &g_define_type_info, 0);
	SoundPulseAudioManager_private_offset = g_type_add_instance_private (sound_pulse_audio_manager_type_id, sizeof (SoundPulseAudioManagerPrivate));
	return sound_pulse_audio_manager_type_id;
}

GType
sound_pulse_audio_manager_get_type (void)
{
	static volatile gsize sound_pulse_audio_manager_type_id__volatile = 0;
	if (g_once_init_enter (&sound_pulse_audio_manager_type_id__volatile)) {
		GType sound_pulse_audio_manager_type_id;
		sound_pulse_audio_manager_type_id = sound_pulse_audio_manager_get_type_once ();
		g_once_init_leave (&sound_pulse_audio_manager_type_id__volatile, sound_pulse_audio_manager_type_id);
	}
	return sound_pulse_audio_manager_type_id__volatile;
}

static void
_vala_sound_pulse_audio_manager_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	switch (property_id) {
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
		g_value_set_object (value, sound_pulse_audio_manager_get_default_output (self));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
		g_value_set_object (value, sound_pulse_audio_manager_get_default_input (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sound_pulse_audio_manager_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	switch (property_id) {
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
		sound_pulse_audio_manager_set_default_output (self, g_value_get_object (value));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
		sound_pulse_audio_manager_set_default_input (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

